function scroll_to(context, speed) {
  if(!speed) {
    speed = 500;
  }
  var offset = 0;
  if(context) {
    offset = context.offset().top;
  }
  $('body,html,document').animate({
    scrollTop: offset
  }, speed);
}

var vm = (function() {
  var t = {};
  t.isMobile = function() {
    return $(document).width() > 700 ? false : true;
  };
  t.player = null;
  t.events = function() {
    $('.vm_insert').click(function(e) {
      e.preventDefault();
      var id = $(this).attr('data-id');
      var title = $('p.title', this).text().replace('VIDEO: ', '');
      if(t.player && t.isMobile() === false) {
        t.updateEmbed(id, title, this);
      } else {
        t.launchPlayer(id, title, this);
      }
    });
  };
  t.launchPlayer = function(id, title, link) {
    var data = {};
    if(title && title !== '') {
      data = {
        id: id,
        name: $('.name', link).html(),
        role: $('.role', link).html(),
        title: title,
        video: t.url(id)
      };
    } else {
      data = {
        id: id,
        video: t.url(id)
      };
    }
    var player = t.template(data);
    $('body').append(player);
    $('#vm_overlay a.close').click(function(e) {
      e.preventDefault();
      $('#vm_overlay').remove();
    });
  };
  t.template = function(data) {
    var html = '<div id="vm_overlay">'+
      '<div class="vm_panel">'+
        '<a href="#" class="close">Close</a>'+
        '<div class="vm_inline">'+
          '<img class="ratio" src="/_/images/ratio.png" alt="" />'+
          '<iframe src="'+data.video+'" frameborder="0" webkitallowfullscreen mozallowfullscreen allowfullscreen></iframe>'+
        '</div>';
    if(data.title) {
      html += '<div class="vm_meta">'+
          '<p class="title">'+data.title+'</p>'+
          '<div class="info">'+
            '<p class="name">'+data.name+'</p>'+
            '<p class="role">'+data.role+'</p>'+
          '</div>'+
        '</div>';
    }
    var extra_discloser = '';
    if(data.id && data.id == '102764186') {
      extra_discloser = '';
    }
    html += '<p class="vm_cta">Advisors can call CNL Securities at <span class="nowrap">866-650-0650</span>.</p>'+
        '<p class="vm_disclaimer"><span class="mobile">By clicking on the play button you are acknowledging you have read the disclosures below.<br /></span>CNL Financial Group is the parent company of CNL Securities, Member <a href="http://www.finra.org/">FINRA</a>/<a href="http://www.sipc.org/">SIPC</a>.<br />This information does not constitute a solicitation of an offer to sell and/or buy any specific security offering. Such an offering is made by the applicable prospectus only. Alternative investments are not suitable for all investors. Investors should consult with a financial professional to determine if the risks associated with an investment are compatible with their investment objective.'+extra_discloser+'</p>'+
      '</div>'+
    '</div>';
    return html;
  };
  t.updateEmbed= function(id, title, link) {
    scroll_to(t.player);
    $('.vm_insert').removeClass('active');
    $(link).addClass('active');
    $('iframe', t.player).attr('src', t.url(id));
    $('h2').text(title);
  };
  t.url = function(id) {
    var autoplay = t.isMobile() === true ? '0' : '1';
    return 'https://player.vimeo.com/video/'+id+'?autoplay='+autoplay;
  };
  t.init = function() {
    if($('#vm_player').length) {
      t.player = $('#vm_player');
    }
    t.events();
  };
  return t;
})();

$(function() {
  vm.init();
});
